#!/bin/bash

#Check the number of connections before connecting
conns_before=$(ps aux | grep pangolin | wc -l 2>&1)

#echo $conns_before

#Ask for the computer name that you wan't to establish the VNC connection to
COMPUTER=$(zenity --entry \
       --width 500 \
       --title "Computer" \
       --text "Enter the computer name you wish to connect to");
       if  [[ "$?" != 0 ]] ; then 
          exit
       fi

#SSHPASS=$(zenity --entry --title="Password" --text="Enter password" --hide-text)

#Show information about connecting
zenity --info --width=400 --text \
    "Next a terminal window will open and it will ask you for University of Helsinki password once or twice depending"

#Start the tunnel in a new terminal window. --The title doesn't follow through--
gnome-terminal --geometry=120x10 --title="SSH Tunnel--Close vncserver with command: vncserver -kill :1 and the connection with CTRL+D or press x" -- \
    ssh -J $USER@pangolin.it.helsinki.fi $USER@$COMPUTER.ad.helsinki.fi -L 5901:127.0.0.1:5901 "vncserver :1; /bin/bash -i"

sleep 0.5

#Check the number of connections after connecting. The connection is live before password is given.
conns_after=$(ps aux | grep pangolin | wc -l 2>&1)

#echo $conns_after

#Check whether connection is OK (if not the program will kill the pending connection and exit) and ask for an answer: Yes opens up vncviewer and No quits. Also the address and port in which to connect to is in the info.
if [ $conns_after -gt $conns_before ] ; then
    zenity --question --width=400 --title="-Yes- to open vncviewer. -No- to quit." --text "Copy this-->127.0.0.1:5901 to the vncviewer. Press Yes after connection is succesful."
    if  [[ "$?" != 0 ]] ; then
        pkill -f '5901:127'
        exit
    else
        vncviewer
    fi
else
    zenity --error --width=400 --height=100 --text "SSH tunnel not active"
fi
