#!/usr/bin/env python3
# -*- coding: utf-8 -*-
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Program: HY user information cache
# Written by Antti Luukkonen <antti.luukkonen@helsinki.fi>
# 23.3.2017

import subprocess
import pwd
import os
import sys

class Usercache:

	def __init__(self):
		
		self.username = pwd.getpwuid(os.getuid()).pw_name
		try:
			userinfo = subprocess.check_output("ldapsearch -o nettimeout=3 cn=" + self.username + " pwdLastSet displayName mail accountExpires homeDirectory homeDrive msExchRecipientDisplayType msExchRecipientTypeDetails", shell=True)
			cache = open("/home/" + self.username + "/.cache/usercache","w")
			cache.write(userinfo)
		except Exception:
			sys.exit()

if __name__ == "__main__":
    Usercache()
